petInfo = { }
local NUM_PET_ABILITIES = 6;
local function getPetInfoFromJournal(i)
   local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle
   if tonumber(i) ~= nil then      
      petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i);
      sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
	  if petInfo.name[name] == nil then 
	     petInfo.name[name] = {} 
	  end
      table.insert(petInfo.name[name], i)
   else
      petID = i
      if petID ~= nil then 
         print(petID) 
         petInfo[petID] = i
      end
      speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle, tradable, unique = C_PetJournal.GetPetInfoByPetID(petID)
   end
   
   if petID ~= nil then
      local health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID)
      local link = C_PetJournal.GetBattlePetLink(petID) or 0
      
      if canBattle then 
         table.insert(petInfo.name, name);
         table.insert(petInfo.peticon, icon);
         table.insert(petInfo.pettype, petType);
         table.insert(petInfo.speciesid, speciesID);
         table.insert(petInfo.creatureid, creatureID);
         table.insert(petInfo.petdesc, description);
         table.insert(petInfo.sourcetext, sourceText);
         table.insert(petInfo.wild, isWildPet);
         table.insert(petInfo.level, level);
         table.insert(petInfo.petid, petID);
         table.insert(petInfo.health, health);
         table.insert(petInfo.maxhealth, maxhealth);
         table.insert(petInfo.attack, attack);
         table.insert(petInfo.speed, speed);
         table.insert(petInfo.rarity, rarity);
         table.insert(petInfo.link, link);
         table.insert(petInfo.index, i);
		 table.insert(petInfo.xp, xp);
		 table.insert(petInfo.tradable, tradable);
		 table.insert(petInfo.unique, unique);
		 table.insert(petInfo.maxxp, maxXp);
		 
         local abilities, levels = C_PetJournal.GetPetAbilityList(speciesID);
         petInfo["petability"][i] = {}
         petInfo["petabilityname"][i] = {}
         petInfo["petabilityicon"][i] = {}
         petInfo["petabilitytext"][i] = {}
         petInfo["petabilityindex"][i] = {}
         sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
         local health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID)
         local abilities, levels = C_PetJournal.GetPetAbilityList(speciesID);
         for j=1,# abilities do
            local abilid, abilname, abilicon, maxCooldown, unparsedDescription, numTurns, abiltype, noStrongWeakHints = C_PetBattles.GetAbilityInfoByID(abilities[j]);
            petInfo["petabilityname"][i][j]= abilname
            petInfo["petabilityicon"][i][j]= abilicon
            petInfo["petabilityindex"][i][j]= abilid
            petInfo["petabilityid"][abilname] = abilid
            
            THIS_PET_BATTLE_ABILITY_INFO = {};
            function THIS_PET_BATTLE_ABILITY_INFO:GetAbilityID() return abilid end
            function THIS_PET_BATTLE_ABILITY_INFO:GetCooldown() return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetRemainingDuration() return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:IsInBattle() return false end
            function THIS_PET_BATTLE_ABILITY_INFO:GetHealth(target) return 100 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetMaxHealth(target) return 100 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetAttackStat(target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetSpeedStat(target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetState(stateID, target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetWeatherState(stateID) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetPetOwner(target) return LE_BATTLE_PET_ALLY end
            function THIS_PET_BATTLE_ABILITY_INFO:HasAura(auraID, target) return false end
            function THIS_PET_BATTLE_ABILITY_INFO:GetPetType(target) if ( self:IsInBattle() ) then error("UI: Unimplemented Function"); else return abiltype end end
            local parsed = SharedPetAbilityTooltip_ParseText(THIS_PET_BATTLE_ABILITY_INFO, unparsedDescription)
            petInfo["petabilitytext"][i][j]= parsed
         end
      end
   else
      if canBattle then
         table.insert(unownedPetInfo.name, name);
         table.insert(unownedPetInfo.peticon, icon);
         table.insert(unownedPetInfo.pettype, petType);
         table.insert(unownedPetInfo.speciesid, speciesID);
         table.insert(unownedPetInfo.creatureid, creatureID);
         table.insert(unownedPetInfo.petdesc, description);
         table.insert(unownedPetInfo.sourcetext, sourceText);
         table.insert(unownedPetInfo.wild, isWildPet);
         table.insert(unownedPetInfo.level, level);
         table.insert(unownedPetInfo.petid, petID);
         table.insert(unownedPetInfo.health, health);
         table.insert(unownedPetInfo.maxhealth, maxhealth);
         table.insert(unownedPetInfo.attack, attack);
         table.insert(unownedPetInfo.speed, speed);
         table.insert(unownedPetInfo.rarity, rarity);
         table.insert(unownedPetInfo.link, link);
         table.insert(unownedPetInfo.index, i);
		 table.insert(unownedPetInfo.xp, xp);
		 table.insert(unownedPetInfo.tradable, tradable);
		 table.insert(unownedPetInfo.unique, unique);
		 table.insert(unownedPetInfo.maxxp, maxXp);      
      end
   end
end


local function ZoneCreator()
   local continents = {GetMapContinents()}
   for i=1,(# continents)/2 do
      con = continents[i * 2]
      ZoneInfo[i] = { continent = con, zones = { } }
      local zones = {GetMapZones(i)}
      --print(con)
      for j=1,(# zones)/2 do
         zon = zones[j * 2]
         --print("     ",zon)
         ZoneInfo[i][j] = { zone = zon, pets = { } }
		 numPets = C_PetJournal.GetNumPets(false)
		 petCount = 0
         for k=1, numPets do
            local _, _, _, _, _, _, _, name, icon, petType, _, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(k)
            if string.find(strlower(sourceText),strlower(zon)) then
			   petCount = petCount + 1
               ZoneInfo[i][j][petCount] = { name = name, icon = icon, petType = petType, sourceText = sourceText, description = description, isWildPet = isWildPet, canBattle = canBattle}
            end
         end
      end
   end
end


function petInfo_Download(msg)
   ZoneInfo = { {
   ["continent"] = { { } }
   } }
   ZoneCreator()
   
   petInfo = {
      ["name"] = { { } },
      ["peticon"] = { },
      ["pettype"] = { },
      ["speciesid"] = { },
      ["creatureid"] = { },
      ["sourcetext"] = { },
      ["petdesc"] = { },
      ["wild"] = { },
      ["cooldown"] = { },
      ["level"] = { },
      ["petid"] = { },
      ["health"] = { },
      ["maxhealth"] = { },
      ["attack"] = { },
      ["speed"] = { },
      ["rarity"] = { },
      ["link"] = { },
      ["index"] = { },
      ["ability"] = { },
      ["petability"] = { { } },
      ["petabilityicon"] = { { } },
      ["petabilitytext"] = { { } },
      ["petabilityname"] = { { } },
      ["petabilityid"] = { { } },
	  ["xp"] = { },
	  ["maxxp"] = { },
	  ["tradable"] = { },
	  ["unique"] = { },
      ["petabilityindex"] = { { } }
   }
   
   petsByZone = { { } }
   
   unownedPetInfo = {
      ["name"] = { { } },
      ["peticon"] = { },
      ["pettype"] = { },
      ["speciesid"] = { },
      ["creatureid"] = { },
      ["sourcetext"] = { },
      ["petdesc"] = { },
      ["wild"] = { },
      ["cooldown"] = { },
      ["level"] = { },
      ["petid"] = { },
      ["health"] = { },
      ["maxhealth"] = { },
      ["attack"] = { },
      ["speed"] = { },
      ["rarity"] = { },
      ["link"] = { },
      ["index"] = { },
      ["ability"] = { },
      ["petability"] = { { } },
      ["petabilityicon"] = { { } },
      ["petabilitytext"] = { { } },
      ["petabilityname"] = { { } },
      ["petabilityid"] = { { } },
	  ["xp"] = { },
	  ["maxxp"] = { },
	  ["tradable"] = { },
	  ["unique"] = { },
      ["petabilityindex"] = { { } }
   }
   
   local p=C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   local numPets, numOwned = p.GetNumPets(false);
   for i=1,numPets do
      getPetInfoFromJournal(i)
   end
end

function printPetInfo(info)
   local index
   if tonumber(info) == nil then      
      index = petInfo[info] 
   else
      index = tonumber(info)
   end
   print(petInfo.link[index])
end

function petChanged(petID)
   local index = petInfo[info]
   getPetInfoFromJournal(index)
end

SLASH_petInfoDl1 = "/petinfodl";
SlashCmdList["petInfoDl"] = petInfo_Download;
petInfo_Download()

SLASH_petInfo1 = "/petinfo";
SlashCmdList["petInfo"] = printPetInfo;



